//********************************************************
// Kurso "Informatika" 2011/12 m.m. pavasario (2) sem.
// 1-as praktinis darbas. Variantas Nr. 106
// Darb atliko: Nerijus Bistrickis
//********************************************************
program pirma;

  const MAXN = 100; { Maksimalus eilui ir stulpeli skaiius }

  type elementoTipas = -1..maxint;
       matrica = array[1..MAXN] of array[1..MAXN] of elementoTipas;

  var A: matrica;
      maxi, maxj: integer;

  procedure nuskaityk_matrica;
    var i, j: integer;
  begin
    readln(maxi, maxj);             { Matricos plotis ir auktis }
    for j := 1 to maxj do begin
      for i := 1 to maxi do
        read(A[i][j]);
      readln()
    end
  end;
  
  procedure skaiciuok_indeksus(sk: integer; var i, j: integer);
  begin
    i := sk mod maxi;
    j := (sk div maxi) + 1;
    if i = 0 then begin
      i := maxi;
      j := j - 1
    end
  end;
  
  procedure spausdink_matrica(sk: integer);
    var i, j, maxj: integer;
  begin
    skaiciuok_indeksus(sk, i, maxj);
    for j := 1 to maxj do begin
      i := 1;
      while (i <= (sk - (j-1) * maxi)) and (i <= maxi) do begin
        write(A[i][j]:5, ' ');
        inc(i)
      end;
      writeln;
    end
  end;
  
  procedure salink_pasikartojancius;
    var i, j, k: integer;
  begin
    for i := 1 to maxi do begin
      j := 1;
      repeat
        k := j + 1;
        while (A[i][j] = A[i][k]) and (k <= maxj) do
        begin
          A[i][k] := 0;
          inc(k)
        end;
        j := k
      until (j >= maxj)
    end;
  end;
  
  procedure trink_nereikalingus_nulius;
    var i, j, k, max0, i0: integer;
  begin
    for j := 2 to maxj do begin
      k := 0;
      max0 := 0;
      i0 := 0;

      { Iekome, kurioje matricos eiluts dalyje yra daugiausiai 0 }
      for i := 1 to maxi do begin
        if A[i][j] = 0 then
          inc(k)
        else
          k := 0;
        if max0 <= k then begin
          max0 := k;
          i0 := (i - k) + 1
        end
      end;
      
      { Paliekame daugiausiai i eils einani 0 ir triname kitus toje eilutje }
      if i0 > 1 then begin
        for i := 1 to (i0 - 1) do       { triname nereikalingus 0 i kairs }
          if A[i][j] = 0 then begin
            k := j - 1;
            while A[i][k] = 0 do
              dec(k);
            A[i][j] := A[i][k]
          end;
        for i := (i0 + max0) to maxi do { triname nereikalingus 0 i deins }
          if A[i][j] = 0 then begin
            k := j - 1;
            while A[i][k] = 0 do
              dec(k);
            A[i][j] := A[i][k]
          end
      end
    end
  end;
  
  procedure suspausk_matrica(var sk: integer);
    var i, j, i1, j1: integer;
        B: matrica;
  begin
    sk := 0;                                     { sk - suspaustos matricos element skaiius }
    for j := 1 to maxj do begin
      i := 1;
      while i <= maxi do begin
        inc(sk);
        skaiciuok_indeksus(sk, i1, j1);
        
        if (A[i][j] <> 0) then begin             { Skaiius > 0, tiesiog perrao }
          B[i1][j1] := A[i][j];
          inc(i)
        end
        else begin
          B[i1][j1] := 0;
          while (A[i][j] = 0) and (i <= maxi) do { Keiia i eils einanius 0,  vien 0 }
            inc(i)
        end
        
      end;
      inc(sk);
      skaiciuok_indeksus(sk, i1, j1);
      B[i1][j1] := -1;                           { raomas eiluts pabaigos simbolis: -1 }
    end;
    A := B
  end;
  
  procedure atstatyk_pradini_pavidala(sk: integer);
    var i, j, i1, j1: integer;
        i2, j2, k, maxj2: integer;
        B: matrica;
  begin
    maxj2 := maxj;
    skaiciuok_indeksus(sk, i, maxj2);
    i1 := 1; j1 := 1;
    for j := 1 to maxj2 do begin
      i := 0;
      while (i <= (sk - (j-1) * maxi)) and (i < maxi) do begin   { Skaiius > 0 tiesiog perrao }
        inc(i);
        if (A[i][j] > 0) then begin
          B[i1][j1] := A[i][j];
          inc(i1)
        end
        else if (A[i][j] = -1) then begin                        { Sutikus -1, perkelia  kit eilut }
          inc(j1);
          i1 := 1;
          k := 0;
          i2 := i + 1; j2 := j;
          if i2 > maxi then begin
            i2 := 1;
            inc(j2)
          end;
          while (A[i2][j2] <> -1) and (i2 <= (sk - (j2-1) * maxi)) do begin  { Skaiiuojam kiek pasikartojani skaii yra eilutje }
            inc(k);
            inc(i2);
            if i2 > maxi then begin
              i2 := 1;
              inc(j2)
            end;
          end;
          k := maxi - k + 1;
        end
        else if (A[i][j] = 0) and (k <= maxi) then begin            { 0-lius keiiam  juos atitinkanius skaiius}
          while k > 0 do begin
            B[i1][j1] := B[i1][j1-1];
            inc(i1);
            dec(k)
          end
        end;
      end;
    end;
    A := B
  end;

  var sk: integer;
begin
  nuskaityk_matrica;
  
  salink_pasikartojancius;
  trink_nereikalingus_nulius;
  suspausk_matrica(sk);
  
  writeln('Suspausta matrica:');
  spausdink_matrica(sk);
  
  atstatyk_pradini_pavidala(sk);
  writeln('Atstatytas pradinis pavidalas:');
  spausdink_matrica(maxi*maxj)
end.
